//wisedb.  (runs on com1)
//This program communicates with the gateway mote via serial port.
//Simulate with GWsim program.

#define STRICT
#include <tchar.h>
#include <windows.h>
#include <iostream>
#include <string>
#include "serial\Serial.h"
#include <math.h>
#include <time.h>
#include <mysql++>
using namespace std;

CSerial serial;



//								***** fix ASSEMBLEPACKET TO BE COMPATIBLE WITH GETPACKET






//	#define START_BYTE			0xa5
#define GATE_ADDR			0x007e
#define GROUP_BYTE			0x7d
#define BROADCAST_ADDR		0xffff
#define PACKETTYPE_QUERY	0x70
#define PACKETTYPE_DATA		0x00
#define RESPONSECHAR		0x27
#define PACKET_LENGTH		36				//includes possibly the crc.. screw it

#define DATATYPE_LIGHT		0x01
#define DATATYPE_TEMP		0x02
#define DATATYPE_HUMID		0x03
#define DATATYPE_BATTERY	0x04

// Define the packet header structure:
#pragma pack(1)
typedef struct header_t {
	//unsigned char	startbyte;
	unsigned short	addr;
	unsigned char	packettype;
	unsigned char	group;
	unsigned char	len;
} header_t;

#define	SIZEOF_HEADER		5

// Data structure:
typedef struct datapacket {
	unsigned short	datatype;					//changed 5/1 per dave.
	unsigned short	datavalue;
} datapacket;

#pragma pack(8)

#define	SIZEOF_DATAPACKET	4		// 2 byte type + 2 byte data

// Raw Data to Lux converter
double convertLightData(double rawData)
{
/*
	Raw data from the TSL2550 has the following form:

	  bit 7: Validity bit (1 = valid)
	  bit 6,5,4: Chord bits = Chord number
	  bit 3,2,1,0: Step bits = Step number

	  Chord value = INT(16.5 x ((2^C) - 1)) where C = chord number (1 - 7)
	  Chord step value = 2^C where C = chord number (1 - 7)

	Conversion is as such:

	ADC Count Value = ((Chord Value) + (Chord Step Value) x (Step number))
	This must be done for both channels (0 & 1)
	Channel 0 is the first byte, Channel 1 is the second byte

	Lux = (Ch0 Counts) x (0.46) x e^(-3.13R)
		where R = (Ch1 Counts) / (Ch0 Counts)
*/
	unsigned char ch0,ch1,ch0_chord_step,ch1_chord_step,chord_num;
	unsigned int ch0_chord, ch1_chord;
	double ch0_counts, ch1_counts, lux;

	ch1 = char(rawData) & 0x0FF;	// Ch1 is the LSByte
	ch0 = (short(rawData) & 0xFF00) >> 8;	// Ch0 is the MSByte

//	printf("ch0 = 0x%04x, \nch1 = 0x%04x\n", ch0,ch1);

	chord_num = (ch0 & 0x70) >> 4;
	ch0_chord = int(16.5 * (pow(2,chord_num)-1));
	ch0_chord_step = pow(2,chord_num);
	ch0 = ch0 & 0x0F;	// ch0 is now ch0 step number
	ch0_counts = ch0_chord + ch0_chord_step * ch0;

//	printf("chord_num = %04u \nch0_chord = %04u \nch_chord_step = %04u \nch0 = %04u \nch0_counts = %04u \n", chord_num, ch0_chord,ch0_chord_step,ch0,ch0_counts);


	chord_num = (ch1 & 0x70) >> 4;
	ch1_chord = int(16.5 * (pow(2,chord_num)-1));
	ch1_chord_step = pow(2,chord_num);
	ch1 = ch1 & 0x0F;	// ch1 is now ch1 step number
	ch1_counts = ch1_chord + ch1_chord_step * ch1;

	printf("\nch0_counts = %04u, \nch1_counts = %04u\n", ch0_counts,ch1_counts);

	if (ch0_counts == 0) {
		lux = 0;
	} else {
		lux = ch0_counts * 0.46 * exp(-3.13*(ch1_counts/ch0_counts));
	}

	return lux;
}


double convertHumidityData(double rawData)
{
/*
	Conversion is as follows:

	RH(linear) = c1 + c2 * rawdata + c3 * rawdata^2

	where:
		rawdata		c1			c2			c3
		12 bit		-4			0.0405		-2.8E-6
		8 bit		-4			0.648		-7.2E-4


*/
	double rh;
	double c1 = -4;
	double c2 = 0.0405;
	double c3 = -2.8e-6;

	rh = c1 + c2*rawData + c3*rawData*rawData;
	return rh;
}

double convertTemperatureData(double rawData)
{
/*
	Conversion is as follows:

	Temp = d1 + d2*rawData

	where:
		VDD			d1 degC		d1 degF
		5V			-40.00		-40.00
		4V			-39.75		-39.50
		3.5V		-39.66		-39.35
		3V			-39.60		-39.28
		2.5V		-39.55		-39.23

	  rawdata		d2 degC		d2 degF
		14 bit		0.01		0.018
		12 bit		0.04		0.072


*/
	double temp;
	double d1 = -39.28;
	double d2 = 0.018;

	temp = d1 + d2*rawData;
	return temp;
}
//packet assembler function										THIS CODE IS NO LONGER CORRECT.  IT DIFFERS FROM THE GETPACKET FUNCTION.
unsigned char *assemblepacket(unsigned char packettype,
						unsigned short address,
						unsigned short moteid,
						unsigned char &len,
						unsigned short args, ...)
{
	printf("assemblepacket(packettype = %d, address = %d, moteid = %d, , args = %d)\n", packettype, address, moteid, args);

	va_list	ap;

	//here is the packet straucture  start
	//	startbyte(1), address(2), type(1), datalength(1), data([datalength])

	unsigned char *packet;

	len = PACKET_LENGTH;


	//The following was for a variable length packet.
/*	len = (args * SIZEOF_DATAPACKET) + SIZEOF_HEADER + (args != 0 ? sizeof(unsigned short) : 0);
	printf("  total packet length = %d\n", len);
	packet = new unsigned char[len];
*/

	packet = new unsigned char[PACKET_LENGTH];

	//This assembles the header of the packet.

	cout << "ASSEMBLEPACKET INSIDE \n";

//	packet[0] = START_BYTE;			//start byte removed for compatability with TinyOS.
	packet[0] = address >> 8;		//	address
	packet[1] = address & 0xff;		//
	packet[2] = GROUP_BYTE;			//GROUP_BYTE is put in just for compatability with TinyOS.  Ignore its value.
	packet[3] = packettype;			//packet type
	packet[4] = args * SIZEOF_DATAPACKET;		//length of data field USED out of the 29 MAXIMUM AVAILABLE in bytes.



	printf("packet[0] = 0x%02x \n", packet[0]);
	printf("packet[1] = 0x%02x \n", packet[1]);
	printf("packet[2] = 0x%02x \n", packet[2]);
	printf("packet[3] = 0x%02x \n", packet[3]);
	printf("packet[4] = 0x%02x \n", packet[4]);

	cout << endl;

	if (args > 0) {
		// Put moteid as an unsigned short into packet[5]:
		*((unsigned short *)&(packet[SIZEOF_HEADER])) = moteid;

		// make a datapacket pointer then assign it to the memory where data[] is supposed to be
		// in the packet. [byte 7]:
		datapacket *data;
		data = (datapacket *) &(packet[SIZEOF_HEADER + sizeof(unsigned short)]);

		va_start(ap, args);
		// args is the number of argument PAIRS ((datatype, datavalue) = 1 pair) after c in the function call:
		// fill up the data[] array with the arguments:
		while (args--) {
			// Grab datatype number and then the datavalue.
			data->datatype = va_arg(ap, unsigned short);		// Data type
			data->datavalue = va_arg(ap, unsigned short);
			// move to the next position to write to in the data structure:
			data++;
		};
		va_end(ap);
	};

	int i;
	cout << "Packet Length: " << PACKET_LENGTH << endl;
		printf("length = 0x%02x, ", len);
		cout << endl;
	for (i = len; i < PACKET_LENGTH-len; i++) {			//fill remaining bytes of payload with zeros.
		packet[i] = 0x00;
	};


	for (i = 0; i < len; i++) {
		printf("0x%02x, ", packet[i]);
	};
	printf("\n");

	cout << "assemblepacket finished\n";
	return packet;
}


unsigned char *getpacket() {								//THIS CODE WORKS PROPERLY WITH THE GATEWAY MOTE, BUT NOT WITH ASSEMBLEPACKET.
	header_t	header;		// temporary header to read in data
								// so we can allocate appropriate amount
								// of memory for "char *packet"

	unsigned char	*packet = NULL;

	//The following code was used when we were using a startbyte.  (removed for TinyOS)
//	serial.Read(&header.startbyte, 1);
//	if (header.startbyte != START_BYTE) return NULL;

	unsigned char zeros;
	unsigned char sechalfaddr;

	serial.Read(&zeros, sizeof(unsigned char));

	if (zeros != 0x00) return NULL;

	serial.Read(&sechalfaddr, sizeof(unsigned char));
	if (sechalfaddr != GATE_ADDR) return NULL;			//typeconversion

	header.addr = 0;
	header.addr = header.addr + sechalfaddr;			//typeconversion


	printf("Reading header (%d bytes)...\n", SIZEOF_HEADER - sizeof(unsigned char));

	// Read the REST of the header after startbyte:

	serial.Read(&header.packettype, sizeof(unsigned char));
	serial.Read(&header.group, sizeof(unsigned char));		//NEW addition 4/29
	serial.Read(&header.len, sizeof(unsigned char));

	printf("Received rest of header\n");

	// Allocate memory for packet (header size + length of data):
//	packet = new unsigned char[SIZEOF_HEADER + header.len];
	packet = new unsigned char[PACKET_LENGTH];			//36 right now

	// Copy data from TEMPORARY header into packet[]
	memcpy(packet, &header, SIZEOF_HEADER);

	printf("Header:\n");
	printf("  address    = 0x%04x\n", header.addr);
	printf("  packettype = 0x%02x\n", header.packettype);
	printf("  group		 = 0x%02x\n", header.group);
	printf("  len        = %d\n", header.len);

	printf("Receiveing data... (%d bytes used out of payload of 29)", header.len);
	// Read the rest of the packet data into the packet:
//	serial.Read(&(packet[SIZEOF_HEADER]), header.len);
	serial.Read(&(packet[SIZEOF_HEADER]), (PACKET_LENGTH - SIZEOF_HEADER));

	printf("done.\n");

	int i;
	for (i = 0; i < PACKET_LENGTH; i++) {
		printf("0x%02x, ", packet[i]);
	};
	printf("\n");


	return packet;
};


bool checkerror(long lLastError, long error){			//Returns 0 upon success (no error)
	if (lLastError != ERROR_SUCCESS){
		cerr << "Win32 Error Code: " << error << endl;
		return 1;
	}
	return 0;
}

const unsigned char storedpwd[5] = {0xE1, 0x5A, 0x8C, 0x6D, 0xA9};

int main() {
	//establish serial connection.
	LONG    lLastError = ERROR_SUCCESS;
	// Attempt to open the serial port (COM1)
	lLastError = serial.Open(_T("COM1"));
	checkerror(lLastError,serial.GetLastError());

	// Setup the serial port (9600,N81) using hardware handshaking
	lLastError = serial.Setup(CSerial::EBaud57600,CSerial::EData8,CSerial::EParNone,CSerial::EStop1);
	checkerror(lLastError,serial.GetLastError());

	// Setup handshaking (none)
	lLastError = serial.SetupHandshaking(CSerial::EHandshakeHardware);
	checkerror(lLastError,serial.GetLastError());

	//Setup read timeouts (blocking - wait until data received.)
	lLastError = serial.SetupReadTimeouts(CSerial::EReadTimeoutBlocking);
	checkerror(lLastError,serial.GetLastError());

	unsigned short moteid;
	unsigned char response;
	unsigned char responsechar = RESPONSECHAR;

	char pwd[6];

	// The following is the password encryption algorithm:  (refer to encrypt.c)
	int i;
	unsigned char key[5];
	for(i=0; i<5; ++i) {
		key[i] = (char)(sin(((double)i / 5.0) * 3.14159 * 2.0 * 333.0) * 127.0) + 128.0;
	};
	for(i=0; i<5; ++i) pwd[i] = storedpwd[i] ^ key[i];  // ^ = xor
	pwd[5] = 0;

	unsigned char *packet;
	unsigned char	packetlen = 0;

	int numents = 0;

	// Pointer to header
	header_t		*hdr;
	// Pointer to data:
	datapacket	*data;

	int mymoteid;
	int data_type;
	double data_value;

	//addresses:  computer = 0x007e,   motes start at 0x0001,    broadcast (all motes) = 0xffff		**modified 4/29
/*
	Wisedb query procedure:
			1. Send Query packet to mote.
			2. for now, query packet will be data(# of bytes) :
					startbyte(1), address(2), type(1), datalength(1), data([datalength]), crc?
			3. This will be the query packet for broadcast 0xff, 0xffff, 0x70, 0x0
					//[this should not be done on an operational system.  for testing with gateway mote only.]
			4. Set to blocking receive mode for 1* second       [* this will eventually depend on mote level?]
			5. If nak is received, resend packet.  If data packet is received, calculate and enter data into MySQL.
	*/

	for(;;) {		//overall loop

/*		for(;;) {		//query loop.. eventually recurse through all motes here
			packetlen = 0;
			packet = NULL;
			packet = assemblepacket(0x70, 0xffff, 0, packetlen, 0);		//thats all I care about on a query packet oka

			serial.Write(packet, packetlen);  //This "queries" the mote

			delete [] packet;

			cout << "sendquery" << endl;
			lLastError = serial.Read(&response, sizeof(response),0,0,1000);  //specifies a timeout of 1 second
			if (lLastError != ERROR_TIMEOUT && response == responsechar) break;
		}
*/
		// Receive the data packet:
		for (;;) {
		packet = getpacket();
		if (packet == NULL) { cout << "Packet not recognized." << endl; continue; }
		else break;
		}

		// Create pointer to a header_t structure at the beginning of the packet[]:
		hdr = (header_t *)&(packet[0]);
		if (hdr->len == 0) {
			cout << "Packet size incorrect." << endl;
			delete [] packet;
			continue;
		};

		if (hdr->packettype == PACKETTYPE_QUERY) {
			cout << "Query packet received and ignored." << endl;
			delete [] packet;
			continue;
		};

		// Yoink the moteid from packet[5] as an unsigned short:
		moteid = *((unsigned short *)&(packet[SIZEOF_HEADER]));

		// Create a pointer to a datapacket starting at packet[~~7~~]:
		data = (datapacket *)&(packet[SIZEOF_HEADER + sizeof(unsigned short)]);		//account for the moteid.

		// Multiple inserts according to size of data:
		numents = (int)((int)hdr->len - sizeof(unsigned short)) / SIZEOF_DATAPACKET;

		cout << "perform insert: " << endl<< "-----------------" << endl;
		try {		//insert data into mySQL database.
			Connection con("wisenet", "job247a.bradley.edu", "wisedb", pwd);  //establish connection to mysql.
			Query query = con.query();


				unsigned short temp_pckt;
				unsigned short temp_pckt2;
//				unsigned short temp_data_value;
//				unsigned short temp_data_type;

				double temp_data_type;
				double temp_data_value;


				temp_pckt = moteid >> 8;
				temp_pckt2 = moteid << 8;

				moteid = temp_pckt | temp_pckt2;		//byte swapola
				mymoteid = moteid;

				printf("MOTEID = 0x%04x, ", moteid);

			cout << "Inserting " << numents << " entries... " << endl;
			for (i = 0; i < numents; i++) {


				temp_pckt = data->datavalue >> 8;
				temp_pckt2 = data->datavalue << 8;

				temp_data_value = temp_pckt | temp_pckt2;		//byte swapola

				temp_pckt = data->datatype >> 8;
				temp_pckt2 = data->datatype << 8;

				temp_data_type = temp_pckt | temp_pckt2;		//byte swapola


//				data_type = data->datatype;
				data_type = temp_data_type;
				  switch (data_type) {
					case DATATYPE_TEMP: data_value = convertTemperatureData(temp_data_value); break;	// -39.28+0.018*temp_data_value; break;
					case DATATYPE_HUMID: data_value = convertHumidityData(temp_data_value); break;	//-4 + 0.0405 * temp_data_value + -0.0000028 * temp_data_value * temp_data_value; break;
					case DATATYPE_LIGHT: data_value = convertLightData(temp_data_value); break;
					default : data_value = temp_data_value;
				  }

				printf("Data_type = 0x%04x, ", data_type);
				printf("Data_value = 0x%04x, ", data_value);


				cout << "Insert datatype " << data_type << " -- value: " << data_value << endl;

				//unsigned char temp_type;
				//temp_type = (unsigned char)data_type;		//convert to 1 byte data_type.

				query.reset();
				query << "insert into test_data (logid,moteid,timestamp,data_type,data_value) values(%0q,%1q,%2,%3,%4)";
				query.parse();
				query.store(0, mymoteid, "now()", data_type, data_value);

				cout << "Inserted row into test_data successfully" << endl << endl;
				cout << "Here is what was inserted:" << endl;
				cout << "logid" << endl;
				cout << "moteid=" << mymoteid << endl;
				cout << "timestamp" << endl;
				cout << "data_type=" << data_type << endl;
				cout << "data_value=" << data_value << endl;
				data++;
			}
		}
		catch (BadQuery er){	// handle any connection
									// or query errors that may come up
			cerr << "Error: " << er.error <<  endl;
			return -1;
		}
		catch (BadConversion er) {
			// we still need to cach bad conversions in case something goes
			// wrong when the data is converted into stock
			cerr << "Error: Tried to convert \"" << er.data << "\" to a \""
				<< er.type_name << "\"." << endl;
			return -1;
		}

		//create time delay seconds.
//		clock_t start = clock();
//		while ((clock() - start) < 15 * CLOCKS_PER_SEC);		//delay 15 seconds.
	};

	serial.Close();
	return 0;
}


